local Ch = CBW_Chaos
local Lib = CBW_Chaos_Library
freeslot("MT_AMTCRAWLA", "MT_TRASHPOT", "MT_XFOCV", "MT_ROBOHOODTWO", "MT_ROBOHOODALPHA", "MT_ROBOHOODBETA", "MT_POPUPEGGMANTURRET", "MT_GIGAPOPUPEGGMANTURRET", "MT_SCREWDRIVER", "MT_FIREMETALL", "MT_FIREMETALL2", "MT_FIREMETALL3", "MT_TURBOROADSTER") //When the load order
freeslot("MT_TELLY", "MT_ORBITALDETON", "MT_ORBITALDETONTWO", "MT_ORBITALDETONTHREE", "MT_BANANASLIPPY", "MT_ZORUATRICKRINGSMON", "MT_ZORUATRICKONESMON", "MT_LASERTELLY", "MT_COOLTELLY")
freeslot("MT_REXROADSTER", "MT_ALARMBOMB", "MT_VOLTTELLY", "MT_VOLTTELLYVOLT", "MT_FIRETELLY", "MT_AQUATELLY", "MT_LASERFIRINOBJECT", "MT_SNIPERJOE", "MT_CANNONJOE", "MT_OLDMISSILESPEWER")
local info = mobjinfo[MT_AMTCRAWLA]
info.name = "AMT Crawla"
info.article = "an"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 12
info.spawnbiome = 'neutral'
info.spawntype = 'enemy'
info.spawnsubtype = 'land'
info.spawnfrequency = 1
info.spawnhealth = $+3
info.painchance = 6
info.flashingtime = 70
info.seesound = sfx_cdfm02
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*5/4

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_AMTCRAWLA)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_AMTCRAWLA)


local info = mobjinfo[MT_TRASHPOT]
info.name = "Trash Pot"
info.chaosmode = true
info.difficulty = 3
info.spawnweight = 5
info.spawnbiome = 'metal'
info.spawntype = 'target'
info.spawnsubtype = {'sniper', 'land'}
info.spawnfrequency = 2
info.spawnhealth = $+6
info.painchance = 6
info.flashingtime = 20
info.bumptype = 2
info.scale = FRACUNIT*2
info.spawnstill = true
info.grounded = true
info.bossregulate = 1
info.flincharmor = true

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_TRASHPOT)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_TRASHPOT)

local info = mobjinfo[MT_XFOCV]
info.name = "Jetty-Vaccum"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 9
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = {'air', 'land'}
info.spawnfrequency = 2
info.painchance = 6
info.spawnhealth = $+2
info.painchance = 6
info.flashingtime = 10
info.bumptype = 1
info.flincharmor = true
info.scale = FRACUNIT*5/4

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_XFOCV)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_XFOCV)

mobjinfo[MT_ROBOHOODTWO].name = 'Multi-Hood'
mobjinfo[MT_ROBOHOODTWO].chaosmode = true
mobjinfo[MT_ROBOHOODTWO].difficulty = 2
mobjinfo[MT_ROBOHOODTWO].spawnbiome = 'medieval'
mobjinfo[MT_ROBOHOODTWO].spawntype = 'enemy'
mobjinfo[MT_ROBOHOODTWO].spawnsubtype = {'sniper','land'}
mobjinfo[MT_ROBOHOODTWO].spawnpriority = 1
mobjinfo[MT_ROBOHOODTWO].spawnweight = 5
mobjinfo[MT_ROBOHOODTWO].spawnfrequency = 2
mobjinfo[MT_ROBOHOODTWO].flags = $|MF_BOUNCE
mobjinfo[MT_ROBOHOODTWO].bumptype = 2
mobjinfo[MT_ROBOHOODTWO].seesound = sfx_peww
mobjinfo[MT_ROBOHOODTWO].flashingtime = 20
mobjinfo[MT_ROBOHOODTWO].flincharmor = true
mobjinfo[MT_ROBOHOODTWO].scale = FRACUNIT*5/4
mobjinfo[MT_ROBOHOODTWO].spawnstill = true


addHook('MobjSpawn',Lib.EnemyInit,MT_ROBOHOODTWO)
addHook('MobjThinker',function(mo)
	if mo.health <= 0 return end
	if Lib.EnemyTic_DangerFloor(mo) return end
	Lib.EnemyTic_ThinkStrafe(mo,TICRATE*2,decidechance,strafechance)
	if Lib.TargetIsMissing(mo,mo.scale*5120)
		mo.target = nil
	end
	if not(mo.target)
		mo.angle = $ + mo.strafe*ANG10
	end
end,MT_ROBOHOODTWO)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ROBOHOODTWO)

mobjinfo[MT_ROBOHOODALPHA].name = 'Alpha-Hood'
mobjinfo[MT_ROBOHOODALPHA].article = "an"
mobjinfo[MT_ROBOHOODALPHA].chaosmode = true
mobjinfo[MT_ROBOHOODALPHA].difficulty = 3
mobjinfo[MT_ROBOHOODALPHA].spawnbiome = 'medieval'
mobjinfo[MT_ROBOHOODALPHA].spawntype = 'target'
mobjinfo[MT_ROBOHOODALPHA].spawnsubtype = {'sniper','land'}
mobjinfo[MT_ROBOHOODALPHA].spawnpriority = 1
mobjinfo[MT_ROBOHOODALPHA].spawnweight = 6
mobjinfo[MT_ROBOHOODALPHA].spawnfrequency = 2
mobjinfo[MT_ROBOHOODALPHA].flags = $|MF_BOUNCE
mobjinfo[MT_ROBOHOODALPHA].bumptype = 2
mobjinfo[MT_ROBOHOODALPHA].seesound = sfx_peww
mobjinfo[MT_ROBOHOODALPHA].flashingtime = 25
mobjinfo[MT_ROBOHOODALPHA].flincharmor = true
mobjinfo[MT_ROBOHOODALPHA].scale = FRACUNIT*2
mobjinfo[MT_ROBOHOODALPHA].color = SKINCOLOR_SEAFOAM
mobjinfo[MT_ROBOHOODALPHA].spawnstill = true
mobjinfo[MT_ROBOHOODALPHA].bossregulate = 2

addHook('MobjSpawn',Lib.EnemyInit,MT_ROBOHOODALPHA)
addHook('MobjThinker',function(mo)
	if mo.health <= 0 return end
	if Lib.EnemyTic_DangerFloor(mo) return end
	Lib.EnemyTic_ThinkStrafe(mo,TICRATE*2,decidechance,strafechance)
	if Lib.TargetIsMissing(mo,mo.scale*5120)
		mo.target = nil
	end
	if not(mo.target)
		mo.angle = $ + mo.strafe*ANG10
	end
end,MT_ROBOHOODALPHA)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ROBOHOODALPHA)


mobjinfo[MT_ROBOHOODBETA].name = 'Beta-Hood'
mobjinfo[MT_ROBOHOODBETA].chaosmode = true
mobjinfo[MT_ROBOHOODBETA].difficulty = 3
mobjinfo[MT_ROBOHOODBETA].spawnbiome = 'medieval'
mobjinfo[MT_ROBOHOODBETA].spawntype = 'target'
mobjinfo[MT_ROBOHOODBETA].spawnsubtype = {'sniper','land'}
mobjinfo[MT_ROBOHOODBETA].spawnpriority = 1
mobjinfo[MT_ROBOHOODBETA].spawnweight = 4
mobjinfo[MT_ROBOHOODBETA].spawnfrequency = 2
mobjinfo[MT_ROBOHOODBETA].flags = $|MF_BOUNCE
mobjinfo[MT_ROBOHOODBETA].bumptype = 2
mobjinfo[MT_ROBOHOODBETA].seesound = sfx_peww
mobjinfo[MT_ROBOHOODBETA].flashingtime = 30
mobjinfo[MT_ROBOHOODBETA].flincharmor = true
mobjinfo[MT_ROBOHOODBETA].scale = FRACUNIT*2
mobjinfo[MT_ROBOHOODBETA].color = SKINCOLOR_VIOLET
mobjinfo[MT_ROBOHOODBETA].spawnstill = true
mobjinfo[MT_ROBOHOODBETA].bossregulate = 2

addHook('MobjSpawn',Lib.EnemyInit,MT_ROBOHOODBETA)
addHook('MobjThinker',function(mo)
	if mo.health <= 0 return end
	if Lib.EnemyTic_DangerFloor(mo) return end
	Lib.EnemyTic_ThinkStrafe(mo,TICRATE*2,decidechance,strafechance)
	if Lib.TargetIsMissing(mo,mo.scale*5120)
		mo.target = nil
	end
	if not(mo.target)
		mo.angle = $ + mo.strafe*ANG10
	end
end,MT_ROBOHOODBETA)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ROBOHOODBETA)

local info = mobjinfo[MT_POPUPEGGMANTURRET]
info.name = "Egg Rocket-Turret"
info.article = "an"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 6
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = 'sniper'
info.spawnfrequency = 1
info.flashingtime = 35
info.bumptype = 1
info.flincharmor = true
info.scale = FRACUNIT*5/4
info.spawnstill = true
info.grounded = true
info.color = -2

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_POPUPEGGMANTURRET)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_POPUPEGGMANTURRET)

local info = mobjinfo[MT_GIGAPOPUPEGGMANTURRET]
info.name = "GigaEgg Beam-Turret"
info.chaosmode = true
info.difficulty = 3
info.spawnweight = 8
info.spawnbiome = 'metal'
info.spawntype = 'target'
info.spawnsubtype = {'sniper', 'land'}
info.spawnfrequency = 1
info.painchance = 6
info.flashingtime = 35
info.bumptype = 2
info.scale = FRACUNIT*3
info.spawnstill = true
info.grounded = true
info.bossregulate = 1
info.flincharmor = true
info.color = SKINCOLOR_AQUA

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_GIGAPOPUPEGGMANTURRET)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_GIGAPOPUPEGGMANTURRET)

local info = mobjinfo[MT_SCREWDRIVER]
info.name = "Screw Bomber"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 7
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = 'sniper'
info.spawnfrequency = 1
info.flashingtime = 10
info.bumptype = 1
info.flincharmor = true
info.scale = FRACUNIT*5/2
info.spawnstill = true
info.grounded = true
info.color = -2

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_SCREWDRIVER)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_SCREWDRIVER)

local info = mobjinfo[MT_FIREMETALL]
info.name = "Fire Met"
info.chaosmode = true
info.difficulty = 0
info.spawnweight = 5
info.spawnbiome = 'fire'
info.spawntype = 'enemy'
info.spawnsubtype = 'land'
info.spawnfrequency = 2
info.flashingtime = 10
info.bumptype = 0
info.flincharmor = true
info.scale = FRACUNIT*5/2

local info = mobjinfo[MT_FIREMETALL2]
info.name = "Inferno Met"
info.article = "an"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 9
info.spawnbiome = 'fire'
info.spawntype = 'enemy'
info.spawnsubtype = 'land'
info.spawnfrequency = 2
info.flashingtime = 15
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*3

local info = mobjinfo[MT_FIREMETALL3]
info.name = "Dragonfire Met"
info.chaosmode = true
info.difficulty = 3
info.spawnweight = 5
info.spawnbiome = 'fire'
info.spawntype = 'target'
info.spawnsubtype = 'land'
info.spawnfrequency = 1
info.flashingtime = 20
info.bumptype = 2
info.bossregulate = 1
info.flincharmor = true
info.scale = FRACUNIT*5



addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_FIREMETALL)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_FIREMETALL)

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_FIREMETALL2)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return true
		end
	end
end,MT_FIREMETALL2)

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_FIREMETALL3)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_FIREMETALL3)


local info = mobjinfo[MT_TURBOROADSTER]
info.name = "Turbo Roadster"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 5
info.spawnbiome = 'neutral'
info.spawntype = 'enemy'
info.spawnsubtype = 'land'
info.spawnfrequency = 2
info.flashingtime = 15
info.bumptype = 1
info.flincharmor = true
info.scale = FRACUNIT*5/2

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_TURBOROADSTER)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_TURBOROADSTER)


local info = mobjinfo[MT_TELLY]
info.name = "Normal Telly"
info.chaosmode = true
info.difficulty = 0
info.spawnweight = 2
info.spawnbiome = 'neutral'
info.spawntype = 'enemy'
info.spawnsubtype = "air"
info.spawnfrequency = 1
info.flashingtime = 15
info.bumptype = 1
info.flincharmor = true
info.color = -2
info.scale = FRACUNIT*5/2


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_TELLY)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_TELLY)


local info = mobjinfo[MT_ORBITALDETON]
info.name = "Orbital Deton MK.I"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 6
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = "air"
info.spawnfrequency = 1
info.flashingtime = 15
info.bumptype = 2
info.flincharmor = true
info.color = SKINCOLOR_EMERALD


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_ORBITALDETON)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ORBITALDETON)



local info = mobjinfo[MT_ORBITALDETONTWO]
info.name = "Orbital Deton MK.II"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 18
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = "air"
info.spawnfrequency = 1
info.flashingtime = 20
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*3/2
info.color = SKINCOLOR_MAGENTA


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_ORBITALDETONTWO)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ORBITALDETONTWO)

local info = mobjinfo[MT_ORBITALDETONTHREE]
info.name = "Orbital Deton MK.III"
info.chaosmode = true
info.difficulty = 3
info.spawnweight = 8
info.spawnbiome = 'metal'
info.spawntype = 'target'
info.spawnsubtype = "air"
info.spawnfrequency = 1
info.flashingtime = 35
info.bumptype = 2
info.flincharmor = true
info.color = SKINCOLOR_CRIMSON
info.scale = FRACUNIT*2
info.bossregulate = 1

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_ORBITALDETONTHREE)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ORBITALDETONTHREE)

local info = mobjinfo[MT_BANANASLIPPY]
info.name = "Sonic 3 Banana"
info.chaosmode = true
info.difficulty = 0
info.spawnweight = 0
info.spawnbiome = 'grass'
info.spawntype = 'hazard'
info.spawnsubtype = "land"
info.spawnfrequency = 1
info.spawnstill = true
info.grounded = true


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_BANANASLIPPY)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_BANANASLIPPY)

local info = mobjinfo[MT_ZORUATRICKRINGSMON]
info.name = "Tricky Fox's Golden Rings"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 0
info.spawnbiome = 'neutral'
info.spawntype = 'hazard'
info.spawnsubtype = "land"
info.spawnfrequency = 1
info.spawnstill = true
info.grounded = true


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_ZORUATRICKRINGSMON)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ZORUATRICKRINGSMON)

local info = mobjinfo[MT_ZORUATRICKONESMON]
info.name = "Tricky Fox's 'free' Life"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 0
info.spawnbiome = 'neutral'
info.spawntype = 'hazard'
info.spawnsubtype = "land"
info.spawnfrequency = 1
info.spawnstill = true
info.grounded = true


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_ZORUATRICKONESMON)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ZORUATRICKONESMON)

local info = mobjinfo[MT_COOLTELLY]
info.name = "Cool Telly"
info.chaosmode = true
info.difficulty = 3
info.spawnweight = 12
info.spawnbiome = 'metal'
info.spawntype = 'target'
info.spawnsubtype = "air"
info.spawnfrequency = 1
info.flashingtime = 50
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*5
info.bossregulate = 1

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_COOLTELLY)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_COOLTELLY)

local info = mobjinfo[MT_LASERTELLY]
info.name = "Laser Telly"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 6
info.spawnbiome = 'neutral'
info.spawntype = 'enemy'
info.spawnsubtype = "air"
info.spawnfrequency = 1
info.flashingtime = 17
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*3


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_LASERTELLY)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_LASERTELLY)

local info = mobjinfo[MT_REXROADSTER]
info.name = "Rex Roadster"
info.chaosmode = true
info.difficulty = 3
info.spawnweight = 5
info.spawnbiome = 'neutral'
info.spawntype = 'target'
info.spawnsubtype = 'land'
info.spawnfrequency = 1
info.flashingtime = 70
info.bumptype = 2
info.flincharmor = true
info.bossregulate = 1
info.scale = FRACUNIT*8

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_REXROADSTER)
addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_REXROADSTER)

addHook('MobjRemoved',function(mo)
	Lib.SpawnFlowers(mo,4,1,true)
	Lib.SpawnFlowers(mo,6,2)
	Lib.SpawnFlowers(mo,10,3)
end,MT_REXROADSTER)

local info = mobjinfo[MT_ALARMBOMB]
info.name = "Tick-Timer"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 1
info.spawnbiome = 'neutral'
info.spawntype = 'hazard'
info.spawnsubtype = {'land', 'sniper'}
info.spawnfrequency = 2
info.scale = FRACUNIT*3
info.color = -2

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_ALARMBOMB)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_ALARMBOMB)

local info = mobjinfo[MT_VOLTTELLY]
info.name = "Volt Telly"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 6
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = {'air', 'land'}
info.spawnfrequency = 2
info.flashingtime = 25
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*3

mobjinfo[MT_VOLTTELLYVOLT].name = "Volt Telly's Zapper"
mobjinfo[MT_VOLTTELLYVOLT].article = nil


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_VOLTTELLY)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return true
		end
	end
end,MT_VOLTTELLY)

local info = mobjinfo[MT_FIRETELLY]
info.name = "Fire Telly"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 7
info.spawnbiome = 'fire'
info.spawntype = 'enemy'
info.spawnsubtype = {'air'}
info.spawnfrequency = 1
info.flashingtime = 0
info.bumptype = 1
info.flincharmor = true
info.scale = FRACUNIT*3


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_FIRETELLY)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_FIRETELLY)

local info = mobjinfo[MT_AQUATELLY]
info.name = "Aqua Telly"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 9
info.spawnbiome = 'water'
info.spawntype = 'enemy'
info.spawnsubtype = {'water', 'watersurface'}
info.spawnfrequency = 1
info.flashingtime = 15
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*3


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_AQUATELLY)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_AQUATELLY)

local info = mobjinfo[MT_LASERFIRINOBJECT]
info.name = "Laser Beamer"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 5
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = {'air', 'land'}
info.spawnfrequency = 1
info.flashingtime = 15
info.bumptype = 1
info.flincharmor = true
info.scale = FRACUNIT*3
info.color = -2


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_LASERFIRINOBJECT)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_LASERFIRINOBJECT)

local info = mobjinfo[MT_SNIPERJOE]
info.name = "Sniper Joe"
info.chaosmode = true
info.difficulty = 1
info.spawnweight = 9
info.spawnbiome = 'neutral'
info.spawntype = 'enemy'
info.spawnsubtype = {'sniper', 'land'}
info.spawnfrequency = 1
info.flashingtime = 20
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*3


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_SNIPERJOE)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_SNIPERJOE)

local info = mobjinfo[MT_CANNONJOE]
info.name = "Cannon Joe"
info.chaosmode = true
info.difficulty = 2
info.spawnweight = 12
info.spawnbiome = 'metal'
info.spawntype = 'enemy'
info.spawnsubtype = {'sniper'}
info.spawnfrequency = 1
info.flashingtime = 25
info.bumptype = 2
info.flincharmor = true
info.scale = FRACUNIT*3
info.spawnstill = true
info.grounded = true
info.color = -2


addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_CANNONJOE)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_CANNONJOE)

local info = mobjinfo[MT_OLDMISSILESPEWER]
info.name = "Ridable-Missile Silo"
info.chaosmode = true
info.difficulty = 0
info.spawnweight = 1
info.spawnbiome = 'amusement'
info.spawntype = 'hazard'
info.spawnsubtype = {'sniper', 'land'}
info.spawnfrequency = 1
info.flashingtime = 25
info.bumptype = 0
info.flincharmor = true
info.harmless = true
info.scale = FRACUNIT*3
info.spawnstill = true
info.grounded = true
info.color = -2
info.spawnangle = true

addHook('MobjSpawn',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.EnemyInit(mo)
	end
end,MT_OLDMISSILESPEWER)

addHook('MobjThinker',function(mo)
	if CBW_Chaos_Library 
		CBW_Chaos_Library.MobjCheckWater(mo)
		if CBW_Chaos_Library.EnemyTic_Flashing(mo)
			return false
		end
	end
end,MT_OLDMISSILESPEWER)